#pragma once

#include <SimoxUtility/json/json.hpp>

#include "forward_declarations.h"


namespace armarx
{
    void to_json(nlohmann::json& j, const ObjectID& value);
    void from_json(const nlohmann::json& j, ObjectID& value);
}

namespace armarx::objpose
{
    void to_json(nlohmann::json& j, const ObjectPose& op);
    void from_json(const nlohmann::json& j, ObjectPose& op);
}


namespace armarx::objects
{
    void to_json(nlohmann::json& j, const SceneObject& rhs);
    void from_json(const nlohmann::json& j, SceneObject& rhs);

    void to_json(nlohmann::json& j, const Scene& rhs);
    void from_json(const nlohmann::json& j, Scene& rhs);
}
