#include "BaseQueryProcessorBase.h"

#include <ArmarXCore/core/logging/Logging.h>


namespace armarx::armem::server::query_proc::base
{

    std::set<query::data::QueryTarget>
    detail::getTargets(const std::vector<query::data::QueryTarget>& _targets)
    {
        std::set<query::data::QueryTarget> targets(_targets.begin(), _targets.end());
        if (targets.empty())
        {
            ARMARX_DEBUG << "Query has no targets - using WM as default.";
            targets.insert(query::data::QueryTarget::WM);
        }
        return targets;
    }

}
