#pragma once

#include <RobotAPI/libraries/armem/core/DataMode.h>
#include <RobotAPI/libraries/armem/client/query/Builder.h>

#include "SnapshotSelectorWidget.h"

class QWidget;
class QTabWidget;
class QPushButton;

namespace armarx::armem::gui
{

    class QueryWidget : public QWidget
    {
        Q_OBJECT
        using This = QueryWidget;

    public:

        QueryWidget();

        armem::DataMode dataMode() const;

        armem::client::QueryInput queryInput();


    public slots:

    signals:
        void storeInLTM();

        // ToDo:
        // void queryChanged(armem::query::data::Input query);


    private slots:

    signals:



    private:

        QCheckBox* _dataCheckBox;
        QPushButton* _storeInLTMButton;

        QTabWidget* _tabWidget;

        SnapshotSelectorWidget* _snapshotSelectorWidget;

    };

}
